/***************************************************************************
 *  Title: Hello world 
 * -------------------------------------------------------------------------
 *    Purpose: A simple hello world example
 *    Author: Stefan Birrer
 *    Version: $Revision: 1.1 $
 *    Last Modification: $Date: 2003/09/29 19:53:53 $
 *    File: $RCSfile: hello.c,v $
 *    Copyright: 2003 by Stefan Birrer
 ***************************************************************************/
/***************************************************************************
 *  ChangeLog:
 * -------------------------------------------------------------------------
 *    $Log: hello.c,v $
 *    Revision 1.1  2003/09/29 19:53:53  sbirrer
 *    - Guide to C with examples
 *
 ***************************************************************************/
	#define __HELLO_IMPL__

  /************System include***********************************************/
	#include <stdio.h>

  /************Private include**********************************************/
	#include "hello.h"

  /************Defines and Typedefs*****************************************/
    /*  #defines and typedefs should have their names in all caps.
     *  Global variables begin with g. Global constants with k. Local
     *  variables should be in all lower case. When initializing
     *  structures and arrays, line everything up in neat columns.
     */
	#define MESSAGE	"hello world!"

  /************Global Variables*********************************************/
	// This static variable is accessible from within all methods in this 
	// function, but not from other files. This is the prefered way for
	// static variables shared among multiple functions (i.e. mutexes).
	// In general this is the most exposed variable you should use in any
	// projects. If you need to go further than this, you may think of
	// revisiting the design of your project.
	static int count = 0;
	
  /************Function Prototypes******************************************/
	void hello1();
	void hello2();

  /************External Declaration*****************************************/

/**************Implementation***********************************************/

void hello()
{
	hello1();
	hello2();
}

void hello1()
{
	count += 1;
	printf("hello1: %s (count = %d)\n", MESSAGE, count);	
}

void hello2()
{
	// a variable may be declared static in the context of a function
	// in this case, the variable will be accessible only from within
	// the context of this function. -> Encapsulation
	// This is the prefered way for static variables if you only need 
	// it within one function.
	static int cnt = 0;
	
	cnt += 2;

	printf("hello2: %s (cnt   = %d)\n", MESSAGE, cnt);
}
	
